/*
    gamglm-predict
    Prediction with Gamma generalized linear model.
    $Id: gamglm-predict.cpp,v 1.1 2014/10/28 08:39:59 daichi Exp $

*/
#include <cstdio>
#include <cstdlib>
#include <vector>
#include "read.h"
#include "learn.h"

using namespace std;

void
usage ()
{
	fprintf(stderr, "usage: gamglm-predict TEST MODEL\n");
	fprintf(stderr, "$Id: gamglm-predict.cpp,v 1.1 2014/10/28 08:39:59 daichi Exp $\n");
	exit(0);
}

int
main (int argc, char *argv[])
{
	vector<double> y;
	vector<vector<int> > features;
	vector<double> wa, wb;
	char *test, *model;

	if (argc != 3)
		usage ();
	else {
		test = argv[1];
		model = argv[2];
	}

	load_model (model, wa, wb);
	load_data (test, y, features);
	predict_model (y, features, wa, wb);

	return 0;

}


