/*
    gslrand.c
    GSL random number generator interface.
    $Id: gslrand.c,v 1.1 2014/12/19 02:40:24 daichi Exp $

 */
#include <time.h>
#include <stdlib.h>
#include <gsl/gsl_rng.h>
#include <gsl/gsl_randist.h>
#include "gslrand.h"

static gsl_rng *r = NULL;

double
gslrand ()
{
	return gsl_rng_uniform (gslrng());
}

double
gslnrand ()
{
	return gsl_ran_ugaussian (gslrng());
}

gsl_rng *
gslrng (void)
{
	unsigned long seed;

	if (r == NULL)
	{
		r = gsl_rng_alloc (gsl_rng_mt19937);
	
		if (getenv("SEED") == NULL)
			seed = time(NULL);
		else
			seed = atoi(getenv("SEED"));
	
		gsl_rng_set (r, seed);
	}
	
	return r;
}

#if 0
#include <stdio.h>

int
main (int argc, char *argv[])
{
	int i, n = atoi(argv[1]);

	for (i = 0; i < n; i++)
		printf("%.7f\n", NRANDOM);
	
}

#endif
