/*
    learn.h
    $Id: learn.h,v 1.5 2014/12/19 02:41:14 daichi Exp $

*/
#ifndef __LEARN_H__
#define __LEARN_H__
#include <vector>

using namespace std;

void learn_model (vector<double> &y, vector<vector<int> > &data,
		  vector<double> &wa, vector<double> &wb,
		  int iters, double eps, double sigma);
void predict_model (vector<double> &y, vector<vector<int> > &data,
		    vector<double> &wa, vector<double> &wb);
void save_model (char *file, vector<double> &wa, vector<double> &wb);
void load_model (char *file, vector<double> &wa, vector<double> &wb);

double lnorm (double w, double sigma);
double spdot (vector<double> &w, vector<int> &v);

double gamglmlik (vector<double> &y, vector<vector<int> > &data,
		  vector<double> &wa, vector<double> &wb);
double gamglmflik (int f, vector<double> &y, vector<vector<int> > &data,
		   vector<vector<int> > &indata,
		   vector<double> &wa, vector<double> &wb);
double gamreglik (double y, vector<int> &data,
		  vector<double> &wa, vector<double> &wb);

int mh_update (vector<double> &w, int f,
	       vector<double> &wa, vector<double> &wb,
	       vector<double> &y, vector<vector<int> > &data,
	       vector<vector<int> > &indata, double eps, double sigma);


#endif
