/*
    read.cpp
    $Id: read.cpp,v 1.3 2014/10/27 01:48:19 daichi Exp $

 */
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <string>
#include <fstream>
#include <iostream>
#include "read.h"
#include "id.h"
#include "util.h"

using namespace std;

bool
read_data (char *file, vector<double> &y, vector<vector<int> > &data)
{
	ifstream ifs (file);
	vector<string> toks;
	string line;
	int i, f, n = 0;

	if (ifs.fail()) {
		perror("can't open data");
		return false;
	}

	while (getline(ifs, line, '\n'))
	{
		toks = parse_line (line);
		
		if (toks.size() > 1)
		{
			y.resize (n + 1);
			data.resize (n + 1);
			
			y[n] = atof(toks[0].c_str());
			
			for (i = 1; i < toks.size(); i++)
			{
				f = stoid (toks[i]);
				data[n].push_back (f);
			}
			n++;
		}
	}

	ifs.close();
}

bool
load_data (char *file, vector<double> &y, vector<vector<int> > &data)
{
	ifstream ifs (file);
	vector<string> toks;
	string line;
	int i, f, n = 0;

	if (ifs.fail()) {
		perror("can't open data");
		return false;
	}

	while (getline(ifs, line, '\n'))
	{
		toks = parse_line (line);
		
		if (toks.size() > 1)
		{
			y.resize (n + 1);
			data.resize (n + 1);
			
			y[n] = atof(toks[0].c_str());
			
			for (i = 1; i < toks.size(); i++)
			{
				f = fstoid (toks[i]);
				if (f >= 0)
				{
					data[n].push_back (f);
				}
			}
			n++;
		}
	}

	ifs.close();
}


