/*
    util.h
    $Id: util.h,v 1.1 2014/10/23 08:18:39 daichi Exp $
*/
#ifndef _UTIL_H_
#define _UTIL_H_
#include <cstdio>
#include <vector>
#include <string>
#include <deque>
#include <utility>
#include <tr1/unordered_map>
#define	 cons	make_pair
#define	 hash_map	tr1::unordered_map
#define  max(a,b)	((a)>(b)?(a):(b))
#define	 append(s,t)	(s.insert (s.end(), t.begin(), t.end()))

using namespace std;

namespace std {
namespace tr1 {
	template <> struct hash <pair<int,int> >
	{
		size_t operator() (const pair<int,int> &x) const
		{
			return x.first * 131 + x.second;
		}
	};
}
}

template <class T> void push_front (vector<T> &v, T &x);
template <class T> void pop_front (vector<T> &v);
template <class T> T unshift (deque<T> &v);
double sum (vector<double> &v);
double logsumexp (double x, double y, int init);
string join (vector<string> &words, string &delim);
bool isspaces (const string &line);
char *strconcat (const char *s, const char *t);
void vec_normalize (double *v, int n);
void matrix_normalize (double **matrix, int rows, int cols, int columnwise);
bool converged (double u, double v, double threshold);
double *drealloc (double *v, int size, int old);
int eprintf (const char *fmt, ...);
int error (const char *fmt, ...);
int vmax (double *v, int n);
int vmax (vector<int> &v);
bool fexists (char *file);
double stof (string &s);
vector<string> parse_line (string &line);
double hashsum (hash_map<int,double> &h);
double hashsum (hash_map<pair<int,int>,double> &h);

#endif

